#include <stdlib.h>
#include <stdio.h>
#include <assert.h>

/* Exercice 1
   mystere(t,3) = 3
   mystere(t,6) = -3
   mystere renvoie le minimum de t[0],...,t[n-1]
   On peut ajouter assert( n>0 )
*/

/* Exercice 2 */
double moyenne(int t[], int n)
{
    double s=0;
    for(int i=0; i<n; i++)
    {
        s+=t[i];
    }
    return s/n;
}

/* Exercice 3 */
void substituer(int t[], int n, int old, int new)
{
    for(int i=0; i<n; i++)
    {
        if(t[i]==old)
        {
            t[i]=new;
        }
    }
}

/* Exercice 4 */
int recherche(int t[], int n, int x)
{
    for(int i=0; i<n; i++)
        if(t[i]==x)
            return i;
    return -1;
}

/* Exercice 5 */
int indiceMaximum(int t[], int n)
{
    assert( n>0 );
    int indice_max = 0;
    for(int i=1; i<n; i++)
    {
        if(t[i]>t[indice_max])
        {
            indice_max = i;
        }
    }
    return indice_max;
}

/* Exercice complémentaire 1 */
int amplitude(int t[], int n)
{
    assert( n>0 );
    int max = t[0];
    int min = t[0];
    for(int i=1; i<n; i++)
    {
        if(t[i]>max)
            max=t[i];
        if(t[i]<min)
            min=t[i];
    }
    return max-min;
}

/* Exercice complémentaire 2 */
int max2(int t[], int n)
{
    assert( n>1 );
    int max;
    int res;

    if(t[0]>=t[1])
    {
        max = t[0];
        res = t[1];
    }
    else
    {
        res = t[0];
        max = t[1];
    }
    for(int i=2; i<n; i++)
    {
        if(t[i]>=max)
        {
            res = max;
            max = t[i];
        }
        else
        {
            if(t[i]>res)
            {
                res = t[i];
            }
        }
    }
    return res;
}

void afficherTableau(int t[], int n)
{
    for(int i=0; i<n; i++)
    {
        printf("%d ",t[i]);
    }
    printf("\n");
}


int main(void)
{
    int t[5];
    t[0]=6;
    t[1]=3;
    t[2]=4;
    t[3]=10;
    t[4]=6;

    afficherTableau(t, 5);

    printf("moyenne : %g\n", moyenne(t,5));

    printf("substituer 6 par 5 : ");
    substituer(t, 5, 6, 5);
    afficherTableau(t, 5);

    printf("rechercher 6 : %d\n", recherche(t, 5, 6));
    printf("rechercher 3 : %d\n", recherche(t, 5, 5));
    printf("indice maximum  : %d\n", indiceMaximum(t, 5));
    printf("amplitude : %d\n", amplitude(t, 5));
    printf("max2 : %d\n", max2(t, 5));
    t[0]=10;
    afficherTableau(t, 5);
    printf("max2 : %d\n", max2(t, 5));

    return EXIT_SUCCESS;
}
